;##################################################################
; TreeViewPanes
;##################################################################

#include "TreeViewPanels.h"

DATA SECTION
	hInstance	HANDLE		?
	hPanel1		HANDLE		?
	hPanel2		HANDLE		?
	hTreeview	HANDLE		?

CODE SECTION

START:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam

	cmp D[uMsg],WM_INITDIALOG
	jne >>.WM_COMMAND
		invoke CreateDialogParam,[hInstance],2000,[hwnd],addr DefPanelProc,0
		mov [hPanel1],eax
		invoke ShowWindow,[hPanel1],SW_HIDE

		invoke CreateDialogParam,[hInstance],3000,[hwnd],addr DefPanelProc,0
		mov [hPanel2],eax
		invoke ShowWindow,[hPanel2],SW_HIDE

		// Just put 2 items in the treeview
		invoke GetDlgItem,[hwnd],1001
		mov [hTreeview],eax

		invoke SetWindowPos,[hPanel1],NULL,150,10,NULL,NULL,SWP_NOSIZE + SWP_NOZORDER + SWP_SHOWWINDOW
		invoke SetWindowPos,[hPanel2],NULL,150,10,NULL,NULL,SWP_NOSIZE + SWP_NOZORDER
		
		invoke TreeviewAddItem,[hTreeview],TVI_ROOT,[hPanel1],"Panel 1"
		// push the first hItem
		push eax
		invoke TreeviewAddItem,[hTreeview],TVI_ROOT,[hPanel2],"Panel 2"
		// Set the treeview to item 1
		pop eax
		invoke SendMessage,[hTreeview],TVM_SELECTITEM,TVGN_CARET,eax
		jmp >.EXIT

	.WM_COMMAND
	cmp D[uMsg],WM_COMMAND
	jne >.WM_NOTIFY

		jmp >.EXIT

	.WM_NOTIFY
	cmp D[uMsg],WM_NOTIFY
	jne >>.WM_CLOSE
		mov edi,[lParam]
		cmp D[edi+NMHDR.code],TVN_SELCHANGED
		jne >>.DEFPROC
			// The selection has changed in the treeview
			// so swap dialogs
			invoke ShowWindow,[edi+NMTREEVIEW.itemOld.lParam],SW_HIDE
			invoke ShowWindow,[edi+NMTREEVIEW.itemNew.lParam],SW_SHOW
			invoke RedrawWindow,[hwnd],NULL,NULL, RDW_INVALIDATE + RDW_UPDATENOW
			mov eax,TRUE
			ret

	.WM_CLOSE
	cmp D[uMsg],WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

DefPanelProc FRAME hwnd,uMsg, wParam, lParam
	
	mov eax,TRUE
	RET
ENDF

TreeviewAddItem FRAME hTrv,hPar, hPanel, pszTitle
	LOCAL	tvins			:TVINSERTSTRUCT

	mov eax,[hPar]
	mov [tvins.hParent],eax

	mov eax,[hPanel]
	mov D[tvins.itemex.lParam],eax

	mov D[tvins.hInsertAfter],0
	mov D[tvins.itemex.mask],TVIF_TEXT + TVIF_PARAM
	mov eax,[pszTitle]
	mov [tvins.itemex.pszText],eax

	invoke SendMessage,[hTrv],TVM_INSERTITEM,0,OFFSET tvins

    ret

ENDF